#!/usr/bin/env python
#	  ________________________________________________________
#	 /_______________________________________________________/|
#	 |							|*|
#	 |	name:			Baltazar		|*|
#	 |	version:		0.1			|*|
#	 |	Last Change:		12. February 2008.	|*|
#	 |                                                     	|*|
#	 |	made by:	Jovicic Nemanja (c) 2008.	|*|
#	 |	email:		nemanja.jovicic@hotmail.com	|*|
#	 |	homepage: 	http://www.njsoft.iz.rs 	|*|
#	 |                                                      |*|
#	 |	made in Serbia					|*|
#	 |______________________________________________________|/

try:
	import re
	import urllib
	import time
	import sys
	import os

	import pango
	from sys import argv
	import gtk
	import gtk.glade
	import pygtk
	pygtk.require("2.0")
	import gobject
except:
	print "Check dependencies! Import library error!"
	exit(1)

try:
	from mechanize import Browser
except:
	print "\nDependencies error! Depends on python-mechanize library.\n"
	exit(1)	



class Baltazar:

	path = argv[0][:argv[0].find('baltazar.py')].strip()
	links=[]
	TotalLinks=-1
	prethodniGotov=True
	dwnStarted=False

	#za sleep funkciju
	sleepSeconds=0
	TimerEnable=False
	
	aboutWindow=None

	jezik=0 #0 engleski, 1 Srpski

	numK = 8 #(32/4) zbog tajmera koji radi na 1/4 sekunde


	def __init__(self):

		
		
		#Set the Glade file
		gladefile = str(self.path)+"baltazar.glade"  
	        self.wTree = gtk.glade.XML(gladefile) 
		
		#Get the Main Window, and connect the "destroy" event
		self.mainWindow = self.wTree.get_widget("mainWindow")

		#add button press event to main window
		#self.mainWindow.add_events(gtk.gdk.BUTTON_PRESS_MASK)
		
		#Create our dictionay and connect it
		dic =	{ 
			"on_quit" : self.Quit,#gtk.main_quit,
			"on_Download_clicked" : self.buttonDownload, 
			"on_AddLink_clicked" : self.addLinks,
			"on_clearButton_clicked" : self.clearList,
			"on_NoKB_changed" : self.paketEdit,
			"on_current_folder_changed" : self.promenaFoldera,
			"on_jezik_changed" : self.promeniJezik,
			"on_AboutBTN_clicked" : self.aboutShow
			}
		self.wTree.signal_autoconnect(dic)

		self.AllLinksEdit = self.wTree.get_widget("AddLinksEdit")
		self.clistLink = self.wTree.get_widget("clistLink")
		self.statusBar = self.wTree.get_widget("statusBar")
		self.progressbar = self.wTree.get_widget("progressbar")
		self.NoKB = self.wTree.get_widget("NoKB")
		self.FolderChooser = self.wTree.get_widget("FolderChooser")
		self.comboBoxJezik = self.wTree.get_widget("jezik")


		self.comboBoxJezik.set_active(0)

		#"sleep" funkcija jer drugachije nemoze :)
		self.timer1=gobject.timeout_add(1000, self.timer)

		self.dwnDir = self.FolderChooser.get_filename()+"/"

		#self.AllLinksEdit.set_text("http://rs125.rapidshare.com/files/30781166/Python_Cookbook.pdf")

		#drink = [ [ "Milk",    "3 Oz" ],
		#	[ "Water",   "6 l" ],
		#	[ "Carrots", "2" ],
		#	[ "Snakes",  "55" ] ]
	   
		#for indx in range(4):
		#	self.clistLink.append(drink[indx])

		

	def addLinks(self,event=0):
		if not self.AllLinksEdit.get_text() =="":

			self.TotalLinks+=1
			self.links.append([self.AllLinksEdit.get_text(),"0"])
			
			self.clistLink.append([self.AllLinksEdit.get_text(),""])

			if self.jezik==0: text = "File "+self.links[self.TotalLinks][0].split('/')[-1]+" added"
			else: text = "Fajl "+self.links[self.TotalLinks][0].split('/')[-1]+" dodan u listu"
			
			self.statusBar.push(0,text)

			self.AllLinksEdit.set_text("")
		else:
			if self.jezik==0: text = "No link!"
			else: text = "Nema linka!"
			self.statusBar.push(0, text)



	def buttonDownload(self,event=0):
		#print "121 buttonDownload"
		if self.TotalLinks>-1:
			prviSpremniLink = self.nadjiPrviSpremanLink()
			if prviSpremniLink>-1 and self.prethodniGotov==True:
				self.dwnStarted=True
				if self.jezik==0: text = "Download is starting..."
				else: text = "Vezite se, skidanje pocinje..."
				self.statusBar.push(0, text)
				
				link = self.links[prviSpremniLink][0]
			
				self.dwn(link)

			elif prviSpremniLink==-1: 
				if self.jezik==0: text = "No link!"
				else: text = "Nema linka!"
				self.statusBar.push(0, text)
				self.progressbar.set_text("")
				self.progressbar.set_fraction(0)
				self.dwnStarted=False
				try:
					gobject.source_remove(self.timer2)
				except:
					pass
			else:
				if self.jezik==0: text = "Something in progress! Wait to complete..."
				else: text = "Proces u toku! Sacekajte da se zavrsi..."
				self.statusBar.push(0, text)

		else: 
			if self.jezik==0: text = "No link!"
			else: text = "Nema linka!"
			self.statusBar.push(0, text)
			self.progressbar.set_text("")
			self.progressbar.set_fraction(0)
			self.dwnStarted=False
			try:
				gobject.source_remove(self.timer2)
			except:
				pass
		

	def clearList(self, event=0):
		if self.dwnStarted==False:
			self.links=[]
			self.clistLink.clear()#.remove(0)
		
			if self.jezik==0: text = "List cleared"
			else: text = "Lista obrisana"
			self.statusBar.push(0, text)

			#self.NoLinks=-1	
			self.TotalLinks=-1
			self.AllLinksEdit.set_text("")
		
			#za sleep funkciju
			self.sleepSeconds=0
			self.TimerEnable=False

			self.state=5

			#if self.jezik==0: text = "Ready..."
			#else: text = "Spreman..."
			self.progressbar.set_text("")
			self.progressbar.set_fraction(0)

		else:
			if self.jezik==0: text = "Something in progress! Wait to complete..."
			else: text = "Proces u toku! Sacekajte da se zavrsi..."
			self.statusBar.push(0, text)

	def Quit(self,event=0):
		gobject.source_remove(self.timer1)
		try:
			gobject.source_remove(self.timer2)
		except:
			pass
		gtk.main_quit()

	def paketEdit(self,event=0):
		self.numK = self.NoKB.get_value_as_int()/4

	def promenaFoldera(self,event=0):
		self.dwnDir = self.FolderChooser.get_filename()+"/"#os.getenv('HOME')+"/Desktop/"

	def nadjiPrviSpremanLink(self):
	
		if self.TotalLinks==-1:
			return -1 #u sluchaju prazne liste

		for i in range(self.TotalLinks+1):
			if self.links[i][1]=="0":
				return i
		#ako ga nije nasao treba isprazniti listu zbog memorije i vratiti -1
		#self.links=[][]
		return -1 #u sluchaju da ne postoji

	def promeniJezik(self, event=0):
		self.jezik = self.comboBoxJezik.get_active()

		addLinkBTN = self.wTree.get_widget("AddLink")
		dwnBTN = self.wTree.get_widget("Download")
		clrBTN = self.wTree.get_widget("clearButton")
		podesavanja = self.wTree.get_widget("label2")
		maxSpeed = self.wTree.get_widget("label3")
		saveIn = self.wTree.get_widget("label5")
		dwnList = self.wTree.get_widget("label6")

		if self.jezik == 0:
			addLinkBTN.set_label("Add link")
			dwnBTN.set_label("Download")
			clrBTN.set_label("Clear list")
			podesavanja.set_text("Settings")
			maxSpeed.set_text("Max speed:")
			saveIn.set_text("Save in...")
			dwnList.set_text("Download list")
		else:
			addLinkBTN.set_label("Dodaj link")
			dwnBTN.set_label("Preuzmi")
			clrBTN.set_label("Obrisi listu")
			podesavanja.set_text("Podesavanja")
			maxSpeed.set_text("Max brzina:")
			saveIn.set_text("Sacuvaj u...")
			dwnList.set_text("Lista za preuzimanje")

#################################################################################
#	 ______________________________________________________________________	#
#	/___________________rapidshare stuff begin____________________________/	#
#										#
#################################################################################


	def timer(self):
		if self.dwnStarted==True and self.prethodniGotov==True:
			if self.sleepSeconds==0:
				#self.progressbar.set_text(str(self.sleepSeconds)+" s...")
				#self.progressbar.set_fraction(1-0.5*self.sleepSeconds)
				self.buttonDownload(None)
			else:	
				if self.jezik==0: text = "Loading next link..."
				else: text = "Ucitavanje sledeceg linka..."
				self.statusBar.push(0, text)	
				self.progressbar.set_text(str(self.sleepSeconds)+" s...")
				self.progressbar.set_fraction(0.5*self.sleepSeconds) #1-0.5... ako ocu unapred da odbrojava
				self.sleepSeconds-=1

		if self.TimerEnable==True:
			if self.state==1:
				ip=self.getBetween(self.htmlDec, 'Your IP address ', ' is already downloading a file.')
				#print "Sa vashe IP adrese "+ip+" se vec skida neki fajl"
				if self.jezik==0: text = "Your IP address "+ip+" is already downloading a file, try later!"
				else: text = "Sa vashe IP adrese "+ip+" se vec skida neki fajl, pokusajte kasnije!"
				self.statusBar.push(0, text)

				#zatvori browser
				self.br.close()
				#obrisi br promenljivu
				del self.br
				#za sleep funkciju
				self.sleepSeconds=0
				self.TimerEnable=False

				self.state=5
				#if self.jezik==0: text = "Ready..."
				#else: text = "Spreman..."
				self.progressbar.set_text("")
				self.progressbar.set_fraction(0)
				self.dwnStarted=False
				self.prethodniGotov=True

			elif self.state==2:
				if self.sleepSeconds==0:
					self.TimerEnable=False
					#zatvori browser
					self.br.close()
					#obrisi br promenljivu
					del self.br
					self.dwn()
					#print "Serveri su preoptereceni sacekajte 2 minute"
					#self.sleepSeconds=120
				else:
					self.sleepSeconds-=1
					if self.jezik==0: text = "Currently a lot of users are downloading files. Wait..."
					else: text = "Serveri su preoptereceni! Ponovno ucitavanje za:"
					self.statusBar.push(0,text)

					self.progressbar.set_text(str(self.sleepSeconds/60) + " m   "+str(self.sleepSeconds%60)+" s...")
					self.progressbar.set_fraction(1-self.sleepSeconds/float(self.Seconds))
					

			elif self.state==3:
				#self.sleepSeconds=int(self.getBetween(self.htmlDec, 'Or try again in about ', ' minutes.'))*60
				if self.sleepSeconds==0:
					self.prethodniGotov = True
					self.TimerEnable=False
					self.buttonDownload(None)
					
				else:
					self.sleepSeconds-=1
					#self.statusBar.push(0,"Jos" + str(self.sleepSeconds/60) + ":"+str(self.sleepSeconds%60))
					if self.jezik==0: text = "Free RapidShare user must wait between two downloads..."
					else: text = "Malopre ste skidali fajl, morate sacekati..."
					self.statusBar.push(0,text)
					self.progressbar.set_text(str(self.sleepSeconds/60) + " m   "+str(self.sleepSeconds%60)+" s...")
					self.progressbar.set_fraction(1-self.sleepSeconds/float(self.Seconds))
					#print "Jos" + str(self.sleepSeconds/60) + ":"+str(self.sleepSeconds%60)
					

			
			elif self.state==4:
				#self.sleepSeconds = int(re.search('var c=[0-9]*',self.htmlDec).group(0)[6:])
				if self.sleepSeconds==0:
					self.TimerEnable=False
					self.fileDownload()

				else:
					self.sleepSeconds-=1
					if self.jezik==0: text = "Free RapidShare user must wait..."
					else: text = "Besplatni korisnici RapidShare-a moraju sacekati..."
					self.statusBar.push(0,text)

					self.progressbar.set_text(str(self.sleepSeconds)+" s...")
					self.progressbar.set_fraction(1-self.sleepSeconds/float(self.Seconds))
	   				#sys.stdout.write(' \rSacekajte '+str(self.sleepSeconds)+' sekundi')
					#sys.stdout.flush()
							
		
		return True
########_________________________________________________________________________



	def htc(self,m):
		return chr(int(m.group(1), 16))

	def urldecode(self,url):
		rex=re.compile('%([0-9a-hA-H][0-9a-hA-H])', re.M)
		return rex.sub(self.htc, url)

	def getBetween(self,data, first, last):
			x = len(first)
			begin = data.find(first) +x
			end = data.find(last, begin)
			return data[begin:end]
########_________________________________________________________________________


######## Funkcija proverava odgovor rapidshare servera __________________________
	def checkServer(self,htmlDec):
		if htmlDec=="":
			return 0 #nista nije ucitano, mada bi ovo trebalo da se nikad ne desi jer postoji try cache za fajl ne postoji

		zzbz=re.search('Your IP address ', htmlDec)
		if not zzbz == None:
			return 1 #vec se skida fajl sa vaseg ip-a
				
		#provera da li je server preopterecen
		zzbz=re.search('Currently a lot of users are downloading files.', htmlDec)
		if not zzbz == None:
			self.sleepSeconds=120
			return 2 #server preopterecen chekaj 2 minuta

		#provera za free
		zzbz=re.search('Instant download access! Or try again in about', htmlDec) 
		if not zzbz == None:
			self.sleepSeconds=int(self.getBetween(self.htmlDec, 'Or try again in about ', ' minutes.'))*60
			return 3 # treba cekati onih 15- minuta

		#provera da li je stranica sa onih 50ak sekundi
		zzbz=re.search('You are not a Premium User and have to wait.', htmlDec)
		if not zzbz == None:
			self.sleepSeconds = int(re.search('var c=[0-9]*',self.htmlDec).group(0)[6:])
			return 4 #treba sachekati 50ak sekundi za free usere
	
		return 5 # nishta se ne deshava... opusteno samo				
		
########_________________________________________________________________________

######## Funkcija koja otvara link i proverava da li je ispravan ________________
	def dwn(self, link):
		self.prethodniGotov=False
		#pravi se instanca mechanize.Browser
		self.br = Browser()
		try:
			#borwser otvara link
			self.br.open(link)
		
			#selektujemo free formu
			self.br.select_form(nr=0)
		
			#klik na free dugme
			response = self.br.submit()
		
			#smestamo kompletan html tekst u promenljivu html
			html = response.read()

		except:
			if self.jezik==0: text = "File doesn't exist! Bad link!"
			else: text = "Fajl ne postoji! Pogresan link!"
			self.statusBar.push(0,text)

			self.br.close()
			#obrisi br promenljivu
			del self.br
			prviSpremniLink = self.nadjiPrviSpremanLink()
	
			if prviSpremniLink>-1:
				self.links[prviSpremniLink][1]="1"
				self.clistLink.remove(0)

			#if self.jezik==0: text = "Ready..."
			#else: text = "Spreman..."
			self.progressbar.set_text("")
			self.progressbar.set_fraction(0)
			self.state=5
			self.TimerEnable=False
			self.prethodniGotov=True
			self.sleepSeconds=2
			#print "Fajl ne postoji!"
			return 0

		self.htmlDec = self.urldecode(html)
			
		self.state = self.checkServer(self.htmlDec)

		self.Seconds=self.sleepSeconds
		self.TimerEnable=True
			
########_________________________________________________________________________

######## Funkcija koja zapocinje download i inicijalizuje tajmer za download ____		
	def fileDownload(self):
		#self.dwnDir = os.getenv('HOME')+"/Desktop/"
		
		#trazimo download link koristeci regular expresions
		url = re.search('action="http://[^"]*', self.htmlDec).group(0)[8:]
		self.file = self.br.open(url)
		self.fileSize = self.file.info().getheader("Content-Length")
		#print "\nDownloading " + url.split('/')[-1] + "..."
		#print self.fileSize
		filename=url.split('/')[-1]
		filename_size=len(filename)
		if filename_size>30: text = filename[:15] +"..."+ filename[filename_size-15:]
		else: text = filename

		if self.jezik==0: text = "Downloading " + text +" | Size: "+self.convertByte(self.fileSize)
		else: text = "Preuzimanje " + text +" | Velicina: "+self.convertByte(self.fileSize)
		self.statusBar.push(0,text)

		try:
			exit = 0
			if os.stat(self.dwnDir+url.split('/')[-1]).st_size == int(self.fileSize):
				exit = 1
		except:
			pass
		if exit == 1:
			#print "fajl vec postoji"
			#fajl ( primer.xxx )vec postoji i zato se pravi kopija ( primer (copy).xxx )
			imeFajla=url.split('/')[-1]
			imeFajla=imeFajla.partition('.')
			imeKopije=imeFajla[0]+" (copy)"+imeFajla[1]+imeFajla[2]
			self.fp = open(self.dwnDir+imeKopije,'w')

		else:
			self.fp = open(self.dwnDir+url.split('/')[-1],'w')
		
		self.downloadedSize = 0


		self.progressbar.set_fraction((float(self.downloadedSize)/float(self.fileSize)))
		self.timer2=gobject.timeout_add(250, self.ddd)
########_________________________________________________________________________


######## Tajmer koji sluzi za download fajla ____________________________________

	def ddd(self):

			#numK = 256
			#self.numK = 64
			st = time.time()
			self.chunk = self.file.read(1024*self.numK)
			sizeOfChunk = len(self.chunk)
			self.downloadedSize += sizeOfChunk
			if not self.chunk:
				self.fp.close()
				if self.jezik==0: text = "File successfully downloaded"
				else: text = "Fajl uspesno skinut"
				self.statusBar.push(2,text)


				#print "\nFile succesufuly downloaded"
				self.TimerEnable=False
						
				#zatvori browser
				self.br.close()
				#obrisi br promenljivu
				del self.br

				prviSpremniLink = self.nadjiPrviSpremanLink()
				#print prviSpremniLink
				#print self.links	
				if prviSpremniLink>-1:
					self.links[prviSpremniLink][1]="1"
					self.clistLink.remove(0)

				#if self.jezik==0: text = "Ready..."
				#else: text = "Spreman..."
				self.progressbar.set_text("")
				self.progressbar.set_fraction(0)
				self.state=5
				self.prethodniGotov=True
				self.sleepSeconds=2
				

				return False

			self.speed =  int( ( sizeOfChunk /( time.time() - st + 0.25 ) ) / 1024 )

			self.fp.write(self.chunk)
			self.fp.flush()
			self.percentage = self.downloadedSize*100/int(self.fileSize)

			if self.speed>0:
				eta=(int(self.fileSize)-self.downloadedSize)/(self.speed*1024)
				if self.jezik==0: text = "Size: "+self.convertByte(self.fileSize)+"| DownSize: "+self.convertByte(self.downloadedSize)+"| Speed: "+str(self.speed)+"KB/s | eta: "+str(eta/60)+"m "+str(eta%60)+"s"
				else: text = "Ukupno: "+self.convertByte(self.fileSize)+"| Skinuto: "+self.convertByte(self.downloadedSize)+"| Brzina: "+str(self.speed)+"KB/s | Jos: "+str(eta/60)+"m "+str(eta%60)+"s"

				

			else:	
				if self.jezik==0: text = "Size: "+self.convertByte(self.fileSize)+"| DownSize: "+self.convertByte(self.downloadedSize)+"| Speed: "+str(self.speed)+"KB/s | eta: ---"
				else: text = "Ukupno: "+self.convertByte(self.fileSize)+"| Skinuto: "+self.convertByte(self.downloadedSize)+"| Brzina: "+str(self.speed)+"KB/s | Jos: ---"
			
			self.statusBar.push(0,text)

			self.progressbar.set_text(str(self.percentage)+"%")
			self.progressbar.set_fraction(float(self.percentage)/100)

			
			return True
			
			#sys.stdout.write('\r                                                                    ')
			#sys.stdout.flush()
			#sys.stdout.write('\r'+str(downloadedSize)+'/'+str(fileSize)+'  '+str(int(percentage))+'%  '+str(speed)+' kb/s                                    ')
			#sys.stdout.flush()
########_________________________________________________________________________


######## Funkcija pretvara bytes u vece jedinice ako je moguce __________________
	def convertByte(self,bytes):
		if long(bytes) >= (1024*1024*1024): 
			return str("%.2f" %(float(bytes) / 1073741824)) + " GB "

		elif  long(bytes) >= (1024*1024): 
			return str("%.2f" %(float(bytes) / 1048576)) + " MB "

		elif  long(bytes) >= (1024): 
			return str("%.2f" %(float(bytes) /1024)) + " KB "

		else:
			return bytes+" B "
########_________________________________________________________________________


#################################################################################
#	 ____________________________________________________________________	#
#	/___________________rapidshare stuff end____________________________/	#
#										#
#################################################################################
#----prikaz about ekrana sa uchitavanjem kontrola-
	def aboutShow(self, event=0):

		if self.aboutWindow == None:
			gladefile = str(self.path)+"about.glade"  
			wTree = gtk.glade.XML(gladefile)
			self.aboutWindow = wTree.get_widget("aboutWindow")

			dic =	{
				"on_buttonHomepage_clicked" : self.homepageOpen,
				"on_aboutWindow_destroy_event" : self.delAbout
				}
			wTree.signal_autoconnect(dic)

			labelVersion = wTree.get_widget("labelVersion")
			labelVersion.modify_font(pango.FontDescription("sans Bold 32"))

			labelVersion = wTree.get_widget("labelVersion2")
			labelVersion.modify_font(pango.FontDescription("sans Bold 32"))

			self.aboutWindow.show()
		else:
			self.aboutWindow.reshow_with_initial_size()

#-------------------------------------------------
	def delAbout(self, event=0):
		del self.aboutWindow

#----open homepage--------------------------------
	def homepageOpen(self, event=0):
		os.system("xdg-open http://www.njsoft.iz.rs")
#-------------------------------------------------



if __name__ == "__main__":
	hwg = Baltazar()
	gtk.main()

